> For the complete documentation index, see [llms.txt](https://docs.flowretail.com/docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.flowretail.com/docs/developers/api-documentation/reports/turnover-report-for-products.md).

# Turnover report for products

Get products turnover report for a time period,\
optionally filtered on a list of product group and UIDs. The report generates sums of sold products and total values.

Required permissions: REPORTING

```json
{"openapi":"3.0.2","info":{"title":"Flow Retail API version 2","version":"2.0.0"},"tags":[{"name":"Reports","description":"Reports"}],"servers":[{"description":"Flow Retail Production","url":"https://api.flowretail.com/v2"},{"description":"Flow Retail Stage","url":"https://api.stage.flowretail.com/v2"}],"security":[{"accessToken":[]},{"authToken":[]},{"integrationToken":[]}],"components":{"securitySchemes":{"accessToken":{"description":"Access token recevied after user login with a deviceToken","scheme":"bearer","type":"http"},"authToken":{"description":"Token received from the auth service","scheme":"bearer","type":"http"},"integrationToken":{"scheme":"bearer","type":"http"}},"requestBodies":{"ProductReportRequest":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductReportRequestSchema"}}},"description":"Product Turnover Request Body"}},"schemas":{"ProductReportRequestSchema":{"title":"ProductReportRequestSchema","type":"object","required":["fromDateTime","storeUids","toDateTime"],"properties":{"brandUids":{"description":"Array of brandUids","type":"array","items":{"$ref":"#/components/schemas/UID"}},"fromDateTime":{"format":"date-time","minLength":10,"type":"string"},"productGroupUids":{"description":"Array of productGroup ids","type":"array","items":{"$ref":"#/components/schemas/UID"}},"storeUids":{"description":"Array of storeUids","type":"array","items":{"$ref":"#/components/schemas/UID"}},"toDateTime":{"format":"date-time","minLength":10,"type":"string"},"groupByUserCode":{"type":"boolean","description":"if true, the excel report returns a response with order items grouped by userCode"},"reportBasis":{"$ref":"#/components/schemas/TurnoverReportBasisENUM"},"tenantUserUid":{"$ref":"#/components/schemas/OptionalUID"},"includeDeliveryCostAdjustments":{"type":"boolean","description":"When true, the spreadsheet includes extra cost-only rows for items delivered on a later date than the sale, where the delivery cost differs from the sale cost price. Used to verify R9 report cost figures.\n"},"includeProductGroupLevels":{"type":"boolean","description":"When true, the spreadsheet appends one column pair per level in the product group hierarchy at the end of each row, one column for the uid and one for the name. The number of column pairs follows the deepest product group path in the report.\n"}}},"UID":{"title":"UID","type":"string","pattern":"^[A-Za-z0-9-_]+"},"TurnoverReportBasisENUM":{"description":"|ENUM      | Description |\n| ---------------- | ------------ |\n| settled | Report on settled orders using settled_at. Includes only orders with status COMPLETE and settleState COMPLETE. |\n| ordered | Report on orders using order_date. Includes orders with status COMPLETE or CONFIRMED. |","enum":["settled","ordered"],"default":"settled","title":"TurnoverReportBasisENUM","type":"string"},"OptionalUID":{"title":"OptionalUID","type":"string","pattern":"^[A-Za-z0-9-_]*"},"ProductReportResponseSchema":{"properties":{"items":{"items":{"$ref":"#/components/schemas/ProductReportResponseItemSchema"},"type":"array"}},"required":["items"],"title":"ProductReportResponseSchema","type":"object"},"ProductReportResponseItemSchema":{"allOf":[{"$ref":"#/components/schemas/StoreReportTurnoverItemSchema"},{"type":"object","required":["brandUid","brandName","productGroupUid","productGroupName","productUid","sku","lastSettledAt"],"properties":{"brandUid":{"$ref":"#/components/schemas/UID"},"brandName":{"type":"string"},"productGroupUid":{"$ref":"#/components/schemas/UID"},"productGroupName":{"type":"string"},"productUid":{"$ref":"#/components/schemas/UID"},"sku":{"type":"string"},"lastSettledAt":{"type":"string","format":"date-time"}}}],"title":"ProductReportResponseItemSchema"},"StoreReportTurnoverItemSchema":{"description":"","properties":{"costAmount":{"type":"integer"},"count":{"type":"integer"},"discountAmount":{"type":"integer"},"name":{"type":"string"},"revenueAmount":{"type":"integer"},"revenuePercent":{"type":"integer"},"storeUid":{"$ref":"#/components/schemas/UID"},"turnoverAmount":{"type":"integer"}},"required":["storeUid","name","turnoverAmount","revenueAmount","revenuePercent","discountAmount","costAmount","count"],"title":"StoreTurnoverReportItem","type":"object"}},"responses":{"ProductReportResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductReportResponseSchema"}},"application/vnd.openxmlformats-officedocument.spreadsheetml.sheet":{"schema":{"type":"string","format":"binary"}}},"description":"Response for Product turnover report."}}},"paths":{"/tenants/{tenantUid}/reports/products":{"post":{"description":"Get products turnover report for a time period,  \noptionally filtered on a list of product group and UIDs.\nThe report generates sums of sold products and total values.\n\nRequired permissions: REPORTING","operationId":"post-tenants-reports-products","parameters":[],"requestBody":{"$ref":"#/components/requestBodies/ProductReportRequest"},"responses":{"200":{"$ref":"#/components/responses/ProductReportResponse"}},"summary":"Turnover report for products","tags":["Reports"]}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.flowretail.com/docs/developers/api-documentation/reports/turnover-report-for-products.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
